import pygame
pygame.mixer.pre_init(44100, -16, 2, 2048)
pygame.mixer.init()

import pgzrun
import random
from pgzhelper import *

WIDTH=800
HEIGHT=600

ENEMY1_CHANCE = 990
ENEMY2_CHANCE = 1003
ENEMY3_CHANCE = 1013

player = Actor('player')
shield = Actor('shield')

drones = []

game_over = Actor('game_over')
game_over.x = 400
game_over.y = 300

start = Actor('start')
start.x = 400
start.y = 300

game_state = 0
game_counter = 0
game_difficulty = 0

bullets = []
bullet_delay = 0

background_images = ['background1','background2','background3']
backgrounds = []
background = Actor(random.choice(background_images))
background.x = 400
background.y = 300
backgrounds.append(background)
background = Actor(random.choice(background_images))
background.x = 400
background.y = -300
backgrounds.append(background)

windmills = []

cloud_images = ['cloud1', 'cloud2']
clouds = []

enemies1 = []
enemies2 = []
enemies3 = []

explosions = []

enemy_bullets = []

powerups = []
powerup_images = ['powerup1', 'powerup2', 'powerup3', 'powerup4', 'powerup5']
powerup1 = 0
shield_power = 0

score = 0

sounds.main_theme.play(-1)

def shoot():
    global bullet_delay

    def shoot1(x, y, angle):
        bullet = Actor('player_bullet')
        bullet.x = x
        bullet.y = y
        bullet.angle = angle
        bullets.append(bullet)

    sounds.sfx_sounds_interaction25.play()
    bullet_delay = 5

    if powerup1 == 0:
        shoot1(player.x, player.y, 90)
        
    elif powerup1 == 1:
        shoot1(player.x - 15, player.y, 90)
        shoot1(player.x + 15, player.y, 90)
        
    elif powerup1 == 2:
        shoot1(player.x, player.y, 110)
        shoot1(player.x, player.y, 90)
        shoot1(player.x, player.y, 70)

    elif powerup1 == 3:
        shoot1(player.x, player.y, 110)
        shoot1(player.x - 15, player.y, 90)
        shoot1(player.x + 15, player.y, 90)
        shoot1(player.x, player.y, 70)

    elif powerup1 >= 4:
        shoot1(player.x, player.y, 115)
        shoot1(player.x, player.y, 100)
        shoot1(player.x, player.y, 90)
        shoot1(player.x, player.y, 80)
        shoot1(player.x, player.y, 65)

    for drone in drones:
        shoot1(drone.x, drone.y, 90)

def explode(actor, life):
    explosion = Actor('explosion1')
    explosion.x = actor.x
    explosion.y = actor.y
    explosion.images = ['explosion1', 'explosion2']
    explosion.fps = 8
    explosion.life = life
    explosions.append(explosion)

def player_controls():
    if keyboard.up:
        player.y -= 5
    if keyboard.down:
        player.y += 5
    if keyboard.right:
        player.x += 5
    if keyboard.left:
        player.x -= 5

    if player.x < 25:
        player.x = 25
    if player.x > 775:
        player.x = 775
    if player.y < 30:
        player.y = 30
    if player.y > 570:
        player.y = 570

def add_enemies():
    if random.randint(0, 1000) > ENEMY1_CHANCE - game_difficulty:
        enemy = Actor('enemy1_1')
        enemy.images = ['enemy1_1', 'enemy1_2']
        enemy.fps = 5
        enemy.y = -50
        enemy.x = random.randint(100, 700)
        enemy.direction = random.randint(-100, -80)
        enemies1.append(enemy)

    if random.randint(0, 1000) > ENEMY2_CHANCE - game_difficulty:
        enemy = Actor('enemy2_1')
        enemy.images = ['enemy2_1', 'enemy2_2', 'enemy2_3']
        enemy.fps = 8
        enemy.y = -50
        enemy.x = random.randint(150, 650)
        enemy.direction = random.randint(-110, -70)
        enemies2.append(enemy)

    if random.randint(0, 1000) > ENEMY3_CHANCE - game_difficulty:
        enemy = Actor('enemy3_1')
        enemy.images = ['enemy3_1', 'enemy3_2']
        enemy.fps = 5
        enemy.y = -50
        enemy.x = random.randint(150, 650)
        enemy.shoot_direction = random.randint(0, 359)
        enemy.shoot_delay = 0
        enemy.hp = 20
        enemy.direction = -90
        enemies3.append(enemy)

def add_powerups():
    if random.randint(0, 1000) > 998:
        powerup = Actor('powerup1')
        powerup.y = -50
        powerup.x = random.randint(100, 700)
        powerups.append(powerup)

def destroy_all_enemies():
    for cList in [enemy_bullets, enemies1, enemies2, enemies3]:
        for actor in cList:
            explode(actor, 15)
        cList.clear()

def on_mouse_down():
    global game_state
    
    if game_state == 0:
        game_state = 1

    player.x = 400
    player.y = 500

def update():
    global bullet_delay, powerup1, powerup2, game_state, score
    global game_counter, game_difficulty, shield_power

    if game_state == 1:
        game_counter += 1
        if game_counter < 1000:
            game_difficulty = 0
        elif game_counter < 2000:
            game_difficulty = 5
        elif game_counter < 3000:
            game_difficulty = 10
        elif game_counter < 4000:
            game_difficulty = 15
        else:
            game_difficulty = 20
        
    
    player_controls()

    for i in range(len(drones)):
        if i == 0:
            target = player
        else:
            target = drones[i-1]
        speed = drones[i].distance_to(target) / 20
        drones[i].move_towards(target, speed)

    if keyboard.space and bullet_delay == 0 and game_state == 1:
        shoot()

    if bullet_delay > 0:
        bullet_delay -= 1

    # Move background
    for background in backgrounds:
        background.y += 2.5
        if background.y > 900:
            background.y -= 1200
            background.image = random.choice(background_images)
            if background.image == 'background1':
                windmill = Actor('windmill')
                windmill.x = 389
                windmill.y = background.y + 45
                windmills.append(windmill)

    # Move willmills
    for windmill in windmills:
        windmill.y += 2.5
        windmill.angle += 2

    # Add clouds
    if random.randint(0, 1000) > 994:
        cloud = Actor(random.choice(cloud_images))
        cloud.y = -50
        cloud.x = random.randint(100, 700)
        clouds.append(cloud)

    # Add Enemies and power ups
    if game_state == 1 or game_state == 2:
        add_enemies()
        add_powerups()

    # Move clouds
    for cloud in clouds:
        cloud.y += 3.5
        if cloud.y > 700:
            clouds.remove(cloud)

    # Move powerup
    for powerup in powerups:
        powerup.y += 4
        if powerup.y > 700:
            powerups.remove(powerup)

    # Move Enemies
    for enemy in enemies1:
        enemy.move_in_direction(4)
        enemy.animate()
        if random.randint(0, 1000) > 990:
            bullet = Actor('enemy_bullet')
            bullet.x = enemy.x
            bullet.y = enemy.y
            bullet.angle = random.randint(0, 359)
            enemy_bullets.append(bullet)
        if enemy.y > 700:
            enemies1.remove(enemy)

    for enemy in enemies2:
        enemy.move_in_direction(5)
        enemy.animate()
        if enemy.y > 400:
            bullet = Actor('enemy_bullet')
            bullet.x = enemy.x
            bullet.y = enemy.y
            bullet.angle = enemy.direction_to(player)
            enemy_bullets.append(bullet)
            enemy.angle = 180
            enemy.direction = 90
        if enemy.y < -50:
            enemies2.remove(enemy)

    for enemy in enemies3:
        enemy.move_in_direction(2)
        enemy.animate()
        if enemy.shoot_delay == 0:
            enemy.shoot_delay = 10
            bullet = Actor('enemy_bullet')
            bullet.x = enemy.x
            bullet.y = enemy.y
            bullet.angle = enemy.shoot_direction
            enemy_bullets.append(bullet)
            enemy.shoot_direction += 15
        else:
            enemy.shoot_delay -= 1
        if enemy.y > 700:
            enemies3.remove(enemy)

    # Move and collide bullets
    for bullet in bullets:
        bullet.move_forward(15)
        if bullet.y < 0:
            bullets.remove(bullet)
            continue
        hit = bullet.collidelist(enemies1)
        if hit != -1:
            bullets.remove(bullet)
            explode(enemies1[hit], 15)
            enemies1.remove(enemies1[hit])
            score += 10
            continue
        hit = bullet.collidelist(enemies2)
        if hit != -1:
            bullets.remove(bullet)
            explode(enemies2[hit], 15)
            enemies2.remove(enemies2[hit])
            score += 10
            continue
        hit = bullet.collidelist(enemies3)
        if hit != -1:
            bullets.remove(bullet)
            enemies3[hit].hp -= 1
            enemies3[hit].image = 'enemy3_hit'
            if enemies3[hit].hp == 0:
                explode(enemies3[hit], 15)
                enemies3.remove(enemies3[hit])
                score += 10
            continue
        hit = bullet.collidelist(powerups)
        if hit != -1:
            bullets.remove(bullet)
            powerups[hit].y -= 40
            powerups[hit].image = random.choice(powerup_images)

    for bullet in enemy_bullets:
        bullet.move_forward(5)
        if bullet.x < 0 or bullet.x > 800 or bullet.y < 0 or bullet.y > 600:
            enemy_bullets.remove(bullet)

    # Animate explosion
    for explosion in explosions:
        explosion.animate()
        explosion.life -= 1
        if explosion.life == 0:
            explosions.remove(explosion)

    # Pickup powerup
    hit = player.collidelist(powerups)
    if hit != -1 and game_state == 1:
        sounds.sfx_sounds_fanfare3.play()
        if powerups[hit].image == 'powerup2':
            powerup1 += 1
        elif powerups[hit].image == 'powerup3':
            if len(drones) < 2:
                drone = Actor('drone')
                drones.append(drone)
        elif powerups[hit].image == 'powerup4':
            if shield_power <= 3:
                shield_power += 1
        elif powerups[hit].image == 'powerup5':
            destroy_all_enemies()
        else:
            score += 100
        powerups.remove(powerups[hit])

    # Move shield and detect collision
    shield.x = player.x
    shield.y = player.y
    for cList in [enemy_bullets, enemies1, enemies2, enemies3]:
        if shield_power > 0:
            hit = shield.collidelist(cList)
            if hit != -1:
                cList.remove(cList[hit])
                shield_power -= 1    

    # Player hit enemy or bullets
    if game_state == 1:
        if (player.collidelist(enemy_bullets) != -1
            or player.collidelist(enemies1) != -1
            or player.collidelist(enemies2) != -1
            or player.collidelist(enemies3) != -1):
            game_state = 2
            explode(player, 100)
            sounds.main_theme.stop()
            sounds.sfx_exp_medium12.play()
            sounds.subdued_theme.play(-1)

def draw():
    screen.clear()
    for background in backgrounds:
        background.draw()
    for windmill in windmills:
        windmill.draw()
    for cloud in clouds:
        cloud.draw()
    for explosion in explosions:
        explosion.draw()
    for bullet in enemy_bullets:
        bullet.draw()
    for enemy in enemies1:
        enemy.draw()
    for enemy in enemies2:
        enemy.draw()
    for enemy in enemies3:
        enemy.draw()
    for powerup in powerups:
        powerup.draw()
    if game_state == 1:
        for drone in drones:
            drone.draw()
        player.draw()
        for _ in range(shield_power):
            shield.draw()
    for bullet in bullets:
        bullet.draw()
    screen.draw.text(str(score), (10, 10), color=(255,255,255), fontsize=40)

    if game_state == 0:
        start.draw()
    if game_state == 2:
        game_over.draw()

pgzrun.go() # Must be last line
